#include "Quests.h"

int getNDigits(int number)
{
    int nDigits = 0;
    while (number != 0) {
        number /= 10;
        ++nDigits;
    }
    return nDigits;
}

//Get data from the task according to the task type
questStruct_t getTaskDatabyType(questEnum_t questType)
{
    questStruct_t questStruct;
    int nameIndex, titleIndex;

    nameIndex = rand()%10;
    titleIndex = rand()%10;

    switch((int)questType)
    {
        case TALK_TO_QUEST:
            //Pegar os dados de NPC
            questStruct.prefix = (char*)malloc(sizeof(char)*(strlen(characterNames[nameIndex])+1));
            strcpy(questStruct.prefix, characterNames[nameIndex]);
            questStruct.suffix = (char*)malloc(sizeof(char)*(strlen(characterTitles[titleIndex])+1));
            strcpy(questStruct.suffix, characterTitles[titleIndex]);
            questStruct.instruction = TALK_TO_INSTRUCTION;
            questStruct.amount = NO_AMOUNT;
            break;
        case GET_ITEM_QUEST:
            //Pegar os dados de Item
            questStruct.prefix = (char*)malloc(sizeof(char)*(strlen(itemNames[nameIndex])+1));
            strcpy(questStruct.prefix, itemNames[nameIndex]);
            questStruct.suffix = (char*)malloc(sizeof(char)*(strlen(itemTitles[titleIndex])+1));
            strcpy(questStruct.suffix, itemTitles[titleIndex]);
            questStruct.instruction = GET_ITEM_INSTRUCTION;
            questStruct.amount = rand()%MAX_ITEMS+1;
            break;
        case DEFEAT_ENEMY_QUEST:
            //Pegar os dados de Inimigo
            questStruct.prefix = (char*)malloc(sizeof(char)*(strlen(enemyColors[nameIndex])+1));
            strcpy(questStruct.prefix, enemyColors[nameIndex]);
            questStruct.suffix = (char*)malloc(sizeof(char)*(strlen(enemyNames[titleIndex])+1));
            strcpy(questStruct.suffix, enemyNames[titleIndex]);
            questStruct.instruction = DEFEAT_ENEMY_INSTRUCTION;
            questStruct.amount = rand()%MAX_ENEMIES+1;
            break;
    }
    return questStruct;
}

//Create the taks for the quest according to the quest type
char* createQuestbyType(questEnum_t questType)
{
    int questSubType;
    char* questText, *newQuestText;

    switch((int)questType)
    {
        case TALK_TO_QUEST:
            questSubType = rand()%4;
            questText = addTaskText(questType);
            if(questSubType == 0)
            {
                newQuestText = createQuestbyType(questType);
                questText = (char*) realloc(questText, sizeof(char)*(strlen(newQuestText)+strlen(questText)+1));
                strcat(questText, newQuestText);
                free(newQuestText);
            }
            break;
        case GET_ITEM_QUEST:
            questText = addTaskText(TALK_TO_QUEST);
            newQuestText = addTaskText(questType);
            questText = (char*) realloc(questText, sizeof(char)*(strlen(newQuestText)+strlen(questText)+1));
            strcat(questText, newQuestText);
            free(newQuestText);
            newQuestText = addTaskText(TALK_TO_QUEST);
            questText = (char*) realloc(questText, sizeof(char)*(strlen(newQuestText)+strlen(questText)+1));
            strcat(questText, newQuestText);
            free(newQuestText);
            break;
        case DEFEAT_ENEMY_QUEST:
            questText = addTaskText(TALK_TO_QUEST);
            newQuestText = addTaskText(questType);
            questText = (char*) realloc(questText, sizeof(char)*(strlen(newQuestText)+strlen(questText)+1));
            strcat(questText, newQuestText);
            free(newQuestText);
            newQuestText = addTaskText(TALK_TO_QUEST);
            questText = (char*) realloc(questText, sizeof(char)*(strlen(newQuestText)+strlen(questText)+1));
            strcat(questText, newQuestText);
            free(newQuestText);
            break;
    }
    return questText;
}

//Parses the text from the task into a readable structure
char* addTaskText(questEnum_t questType)
{
    int textStringSize, amountDigits;
    char *questText, *amountText;
    questStruct_t questStruct;

    questStruct = getTaskDatabyType(questType);

    textStringSize = strlen(questStruct.instruction) + strlen(questStruct.prefix) + 1 + strlen(questStruct.suffix) + 2;
    if(questStruct.amount > 0)
    {
        amountDigits = getNDigits(questStruct.amount);
        textStringSize+=amountDigits;
    }

    questText = (char*) malloc(sizeof(char)*textStringSize);

    strcpy(questText, questStruct.instruction);
    if(questStruct.amount > 0)
    {
            amountText = (char*) malloc(sizeof(char)*(amountDigits+1));
            sprintf(amountText, "%d ", questStruct.amount);
            strcat(questText, amountText);
    }

    strcat(questText, questStruct.prefix);
    strcat(questText, " ");
    strcat(questText, questStruct.suffix);
    strcat(questText, "\n");

    free(questStruct.prefix);
    free(questStruct.suffix);
    return questText;
}
